this.medical_kit_secret_event <- this.inherit("scripts/events/event", {
	m = {
		Tailor = null,
		Story = "",
	},
	function create()
	{
		this.m.ID = "event.medical_kit_secret";
		this.m.Title = "During camp...";
		this.m.Cooldown = 1.0 * this.World.getTime().SecondsPerDay;
		this.m.Screens.push({
			ID = "A",
			Text = "[img]gfx/ui/events/event_51.png[/img]{You sit near campfire, when %tailor% come to you.%SPEECH_ON%I noticed we carry a lot of bandages and antidots without any special bags. It\'d be wise if we will keep it together in one or more medical kits. I saw it before. %story%%SPEECH_OFF%You think it\'s really good idea.}",
			Image = "",
			List = [],
			Characters = [],
			Options = [
				{
					Text = "Maybe you are right.",
					function getResult( _event )
					{
						return 0;
					}

				}
			],
			function start( _event )
			{
				this.Characters.push(_event.m.Tailor.getImagePath());

				local itemResearched = this.new("scripts/items/accessory/medical_kit_item");
				this.List.push({
					id = 10,
					icon = "ui/items/" + itemResearched.getIcon(),
					text = "You get recipe of " + itemResearched.getName()
				});

				this.World.Tags.set("MedicalKitSecret", true);
			}
		});
	}

	function onUpdateScore()
	{
		if (this.World.Tags.get("MedicalKitSecret") == true)
		{
			return;
		}

		local brothers = this.World.getPlayerRoster().getAll();
		local candidates_tailor = [];
		local hasBandages = 0;
		local hasAntidots = 0;

		foreach( bro in brothers )
		{
			if (bro.getBackground().getID() == "background.shepherd" || bro.getBackground().getID() == "background.tailor" || bro.getBackground().getID() == "background.messenger")
			{
				candidates_tailor.push(bro);
			}

			local items = bro.getItems().getAllItems();

			foreach( item in items )
			{
				if (item != null && item.getID() == "accessory.antidote")
				{
					hasAntidots += 1;
				}

				if (item != null && item.getID() == "accessory.bandage")
				{
					hasBandages += 1;
				}
			}
		}

		if (candidates_tailor.len() == 0 || hasAntidots < 2 || hasBandages < 2)
		{
			return;
		}

		this.m.Tailor = candidates_tailor[this.Math.rand(0, candidates_tailor.len() - 1)];

		if (this.m.Tailor.getBackground().getID() == "background.shepherd")
		{
			this.m.Story = "When I was shepherd, wolfs and webknechts often bite sheeps, I cured bulk of my flock with this kit."
		}

		if (this.m.Tailor.getBackground().getID() == "background.tailor")
		{
			this.m.Story = "I made a lot of medical kit - it was very demandable during the war, it saved a lot of lifes."
		}

		if (this.m.Tailor.getBackground().getID() == "background.messenger")
		{
			this.m.Story = "When I was messenger, I was delivering not only dispatches, sometimes I had to bring a few medical kits for our army. It\'s really helpful item."
		}

		this.m.Score = 500;
	}

	function onPrepare()
	{
	}

	function onPrepareVariables( _vars )
	{
		_vars.push([
			"tailor",
			this.m.Tailor.getNameOnly()
		]);
		_vars.push([
			"story",
			this.m.Story
		]);
	}

	function onClear()
	{
		this.m.Tailor = null;
		this.m.Story = "";
	}
});
