this.scare_potion_secret_event <- this.inherit("scripts/events/event", {
	m = {
		Historian = null,
	},
	function create()
	{
		this.m.ID = "event.scare_potion_secret";
		this.m.Title = "During camping";
		this.m.Cooldown = 1.0 * this.World.getTime().SecondsPerDay;
		this.m.Screens.push({
			ID = "A",
			Text = "[img]gfx/ui/events/event_51.png[/img]{You find %historian% reading ancient book. He mumbles strange words and draws symbols on ground. Finally he notices you and excited says %SPEECH_ON%That\'s amazing, I\'ve coped with decryption text in this book - it contains recipe of liquid fear. Author said a few drops of potion can make flee even orc. But I have doubts could we manage to create it rightly. Anyway it\'s helpful knowledge, give me piece of papper, I\'ll jot it down.%SPEECH_OFF%You take instruction from him and put it into day book.}",
			Image = "",
			List = [],
			Characters = [],
			Options = [
				{
					Text = "Good news.",
					function getResult( _event )
					{
						return 0;
					}

				}
			],
			function start( _event )
			{
				this.Characters.push(_event.m.Historian.getImagePath());

				local itemResearched = this.new("scripts/items/tools/scare_potion_item");
				this.List.push({
					id = 10,
					icon = "ui/items/" + itemResearched.getIcon(),
					text = "You get recipe of " + itemResearched.getName()
				});

				this.World.Tags.set("ScarePotionSecret", true);
			}
		});
	}

	function onUpdateScore()
	{
		if (this.World.Tags.get("ScarePotionSecret") == true)
		{
			return;
		}

		local stash = this.World.Assets.getStash().getItems();
		local hasItem = false;

		foreach( item in stash )
		{
			if (item != null && item.getID() == "misc.ornate_tome")
			{
				hasItem = true;
				break;
			}
		}

		if (!hasItem)
		{
			return;
		}

		local brothers = this.World.getPlayerRoster().getAll();
		local candidates_historian = [];

		foreach( bro in brothers )
		{
			if (bro.getBackground().getID() == "background.historian")
			{
				candidates_historian.push(bro);
			}
		}

		if (candidates_historian.len() == 0)
		{
			return;
		}

		this.m.Historian = candidates_historian[this.Math.rand(0, candidates_assasin.len() - 1)];
		this.m.Score = 500;
	}

	function onPrepare()
	{
	}

	function onPrepareVariables( _vars )
	{
		_vars.push([
			"historian",
			this.m.Historian.getNameOnly()
		]);
	}

	function onClear()
	{
		this.m.Historian = null;
	}
});
