this.broken_elbow_joint_injury <- this.inherit("scripts/skills/injury_permanent/permanent_injury", {
	m = {
		Painless = false
	},
	function create()
	{
		this.permanent_injury.create();
		this.m.ID = "injury.broken_elbow_joint";
		this.m.Name = "Broken Elbow Joint";
		this.m.Description = "A broken elbow that never fully healed hinders all movement of the arm and severely reduces combat effectiveness.";
		this.m.Icon = "ui/injury/injury_permanent_icon_08.png";
	}

	function getTooltip()
	{
		local ret = [
			{
				id = 1,
				type = "title",
				text = this.getName()
			},
			{
				id = 2,
				type = "description",
				text = this.getDescription()
			},
			{
				id = 7,
				type = "text",
				icon = "ui/icons/melee_skill.png",
				text = "[color=" + this.Const.UI.Color.NegativeValue + "]-" + (this.m.Painless ? 10 : 20) + "%[/color] Melee Skill"
			},
			{
				id = 7,
				type = "text",
				icon = "ui/icons/ranged_skill.png",
				text = "[color=" + this.Const.UI.Color.NegativeValue + "]-" + (this.m.Painless ? 10 : 20) + "%[/color] Ranged Skill"
			},
			{
				id = 7,
				type = "text",
				icon = "ui/icons/melee_defense.png",
				text = "[color=" + this.Const.UI.Color.NegativeValue + "]-" + (this.m.Painless ? 15 : 30) + "%[/color] Melee Defense"
			},
			{
				id = 16,
				type = "text",
				icon = "ui/icons/special.png",
				text = "Is always content with being in reserve"
			}
		];
		this.addTooltipHint(ret);
		return ret;
	}

	function onUpdate( _properties )
	{
		this.m.Painless = this.getContainer().getActor().getSkills().hasSkill("effects.bull_potion");

		_properties.MeleeSkillMult *= this.m.Painless ? 0.9 : 0.8;
		_properties.RangedSkillMult *= this.m.Painless ? 0.9 : 0.8;
		_properties.MeleeDefenseMult *= this.m.Painless ? 0.85 : 0.7;
		_properties.IsContentWithBeingInReserve = true;
	}

	function onApplyAppearance()
	{
	}

});
