this.weakened_heart_injury <- this.inherit("scripts/skills/injury_permanent/permanent_injury", {
	m = {
		Painless = false
	},
	function create()
	{
		this.permanent_injury.create();
		this.m.ID = "injury.weakened_heart";
		this.m.Name = "Weakened Heart";
		this.m.Description = "Past injuries left this character with a weakened heart, severely lowering his constitution.";
		this.m.Icon = "ui/injury/injury_permanent_icon_14.png";
	}

	function getTooltip()
	{
		local ret = [
			{
				id = 1,
				type = "title",
				text = this.getName()
			},
			{
				id = 2,
				type = "description",
				text = this.getDescription()
			},
			{
				id = 7,
				type = "text",
				icon = "ui/icons/health.png",
				text = "[color=" + this.Const.UI.Color.NegativeValue + "]-" + (this.m.Painless ? 15 : 30) + "%[/color] Hitpoints"
			},
			{
				id = 16,
				type = "text",
				icon = "ui/icons/special.png",
				text = "Is always content with being in reserve"
			}
		];
		this.addTooltipHint(ret);
		return ret;
	}

	function onUpdate( _properties )
	{
		this.m.Painless = this.getContainer().getActor().getSkills().hasSkill("effects.bull_potion");

		_properties.HitpointsMult *= this.m.Painless ? 0.85 : 0.7;
		_properties.IsContentWithBeingInReserve = true;
	}

	function onApplyAppearance()
	{
	}

});
